;; expression [ACL2-var var map] -> [ACL2-var var map]
(defun expression-name-map (exp map)
  (cond ((equal (car exp) 'literal-expression)
	 map)
	((equal (car exp) 'id-expression)
	 (map.add-overwrite map
			    (var.ACL2-var (l.find exp ':var))
			    (var.program-var (l.find exp ':var))))
	((equal (car exp) 'unary-expression)
	 (expression-name-map (l.find exp ':operand) map))
	((equal (car exp) 'binary-expression)
	 (expression-name-map (l.find exp ':operand1)
			      (expression-name-map (l.find exp ':operand2) map)))
	((equal (car exp) 'nondeterministic-expression)
	 map) ;;(list (list 'nondet 'nondet) (list 'counter 'nat)))
	((equal (car exp) 'conditional-expression)
	 (expression-name-map (l.find exp ':test)
			      (expression-name-map (l.find exp ':then)
						    (expression-name-map (l.find exp ':else) map))))
	(t (error 'no-expression (list exp)))))

;; statement [ACL2-var var map] -> [ACL2-var var map]
(defun statement-name-map (stm map)
  (cond ((equal (car stm) 'compound-statement)
	 (list.foldr (lambda (stm acc)
		       (statement-name-map stm acc))
		     map (l.find stm ':statements)))
	((equal (car stm) 'if-then-statement)
	 (expression-name-map (l.find stm ':test)
			      (statement-name-map (l.find stm ':then) map)))
	((equal (car stm) 'if-then-else-statement)
	 (expression-name-map (l.find stm ':test)
		     (statement-name-map (l.find stm ':then)
				 (statement-name-map (l.find stm ':else) map))))
	((equal (car stm) 'while-statement)
	 (expression-name-map (l.find stm ':test)
			      (statement-name-map (l.find stm ':body) map)))
	((equal (car stm) 'do-statement)
	 (error 'unimplemented (list stm)))
	((equal (car stm) 'for-statement)
	 (statement-name-map (l.find stm ':init)
			     (statement-name-map (l.find stm ':iter)
						 (statement-name-map (l.find stm ':body)
								     (expression-name-map (l.find stm ':test) map)))))
	((equal (car stm) 'break-statement)
	 map)
	((equal (car stm) 'continue-statement)
	 map)
	((equal (car stm) 'empty-statement)
	 map)
	((equal (car stm) 'declaration-statement)
	 (map.add-overwrite (expression-name-map (l.find stm ':initializer) map)
			    (var.ACL2-var (l.find (l.find stm ':declaring) ':var))
			    (var.program-var (l.find (l.find stm ':declaring) ':var))))
			    
	((equal (car stm) 'assignment-statement)
	 (map.add-overwrite (expression-name-map (l.find stm ':expression) map)
			    (var.ACL2-var (l.find (l.find stm ':lvalue) ':var))
			    (var.program-var (l.find (l.find stm ':lvalue) ':var))))
	((equal (car stm) 'expression-statement)
	 (error 'unimplemented (list stm)))
	((equal (car stm) 'return-statement)
	 map)
	((equal (car stm) 'assert-statement)
	 map)
	((equal (car stm) 'goto-statement)
	 map)
	((equal (car stm) 'label-statement)
	 map)
	(t (error 'no-statement (list stm)))))

;; program [ACL2-var var map] -> [ACL2-var var map]
(defun program-name-map (prgm map)
  (list.foldr #'(lambda (declaration map)
		  (cond ((equal (car declaration) 'simple-declaration)
			 (map.add-overwrite (expression-name-map (l.find declaration ':initializer) map)
					    (var.ACL2-var (l.find (l.find declaration ':declaring) ':var))
					    (var.program-var (l.find (l.find declaration ':declaring) ':var))))
			((equal (car declaration) 'function-declaration)
			 (statement-name-map (l.find declaration ':body)
					     (list.foldr #'(lambda (declaring map) 
							     (map.add-overwrite map
										(var.ACL2-var (l.find declaring ':var))
										(var.program-var (l.find declaring ':var))))
							 map (l.find declaration ':parameters))))
			(t (error 'no-declaration (list declaration)))))
	      map (l.find prgm ':declarations)))

;; expression [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun expression-constants (exp acc)
  (cond ((equal (car exp) 'literal-expression) 
	 (list-union (list (list (l.find exp ':value) (type-to-ACL2-type (l.find exp ':type)))) acc))
	((equal (car exp) 'id-expression)
	 acc)
	((equal (car exp) 'unary-expression)
	 (expression-constants (l.find exp ':operand) acc))
	((equal (car exp) 'binary-expression)
	 (expression-constants (l.find exp ':operand1)
			       (expression-constants (l.find exp ':operand2) acc)))
	((equal (car exp) 'nondeterministic-expression)
	 acc)
	((equal (car exp) 'conditional-expression)
	 (expression-constants (l.find exp ':test)
			       (expression-constants (l.find exp ':then)
						     (expression-constants (l.find exp ':else) acc))))
	(t (error 'no-expression (list exp)))))

;; statement [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun statement-constants (stm acc)
  (cond ((equal (car stm) 'compound-statement)
	 (list.foldr (lambda (stm acc)
		       (statement-constants stm acc))
		     acc (l.find stm ':statements)))
	((equal (car stm) 'if-then-statement)
	 (expression-constants (l.find stm ':test)
			      (statement-constants (l.find stm ':then) acc)))
	((equal (car stm) 'if-then-else-statement)
	 (expression-constants (l.find stm ':test)
		     (statement-constants (l.find stm ':then)
				 (statement-constants (l.find stm ':else) acc))))
	((equal (car stm) 'while-statement)
	 (expression-constants (l.find stm ':test)
			      (statement-constants (l.find stm ':body) acc)))
	((equal (car stm) 'do-statement)
	 (error 'unimplemented (list stm)))
	((equal (car stm) 'for-statement)
	 (statement-constants (l.find stm ':init)
			      (statement-constants (l.find stm ':iter)
						   (statement-constants (l.find stm ':body)
									(expression-constants (l.find stm ':test) acc)))))
	((equal (car stm) 'break-statement)
	 acc)
	((equal (car stm) 'continue-statement)
	 acc)
	((equal (car stm) 'empty-statement)
	 acc)
	((equal (car stm) 'declaration-statement)
	 (expression-constants (l.find stm ':initializer) acc))
	((equal (car stm) 'assignment-statement)
	 (expression-constants (l.find stm ':expression) acc))
	((equal (car stm) 'expression-statement)
	 (error 'unimplemented (list stm)))
	((equal (car stm) 'return-statement)
	 (expression-constants (l.find stm ':expression) acc))
	((equal (car stm) 'assert-statement)
	 (expression-constants (l.find stm ':expression) acc))
	((equal (car stm) 'goto-statement)
	 acc)
	((equal (car stm) 'label-statement)
	 acc)
	(t (error 'no-statement (list stm)))))

;; program [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun program-constants (prgm acc)
  (list.foldr #'(lambda (declaration acc)
		  (cond ((equal (car declaration) 'simple-declaration)
			 (expression-constants (l.find declaration ':initializer) acc))
			((equal (car declaration) 'function-declaration)
			 (statement-constants (l.find declaration ':body) acc))))
	      acc (l.find prgm ':declarations)))

(defun expression-operations (exp)
  (cond ((equal (car exp) 'literal-expression) 
	 ())
	((equal (car exp) 'id-expression)
	 ())
	((equal (car exp) 'unary-expression)
	 (list-union (list (unary-operator-to-ACL2-unary-operator (l.find exp ':operator)))
		     (expression-operations (l.find exp ':operand))))
	((equal (car exp) 'binary-expression)
	 (list-union (list (binary-operator-to-ACL2-binary-operator (l.find exp ':operator)))
		     (list-union (expression-operations (l.find exp ':operand1))
				 (expression-operations (l.find exp ':operand2)))))
	((equal (car exp) 'nondeterministic-expression)
	 ())
	((equal (car exp) 'conditional-expression)
	 (list-union (expression-operations (l.find exp ':test))
		     (list-union (expression-operations (l.find exp ':then))
				 (expression-operations (l.find exp ':else)))))
	(t (error 'no-expression (list exp)))))

(defun statement-operations (stm)
(cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm acc)
			 (list-union (statement-operations stm) acc))
		     () (l.find stm ':statements)))
      ((equal (car stm) 'if-then-statement)
       (list-union (expression-operations (l.find stm ':test))
		   (statement-operations (l.find stm ':then))))
      ((equal (car stm) 'if-then-else-statement)
       (list-union (expression-operations (l.find stm ':test))
		   (list-union (statement-operations (l.find stm ':then))
			       (statement-operations (l.find stm ':else)))))
      ((equal (car stm) 'while-statement)
       (list-union (expression-operations (l.find stm ':test))
		   (statement-operations (l.find stm ':body))))
      ((equal (car stm) 'do-statement)
       (list-union (expression-operations (l.find stm ':test))
		   (statement-operations (l.find stm ':body))))
      ((equal (car stm) 'for-statement)
       (list-union (statement-operations (l.find stm ':init))
		   (list-union (statement-operations (l.find stm ':iter))
			       (list-union (statement-operations (l.find stm ':body))
					   (expression-operations (l.find stm ':test))))))
      ((equal (car stm) 'break-statement)
       ())
      ((equal (car stm) 'continue-statement)
       ())
      ((equal (car stm) 'empty-statement)
       ())
      ((equal (car stm) 'declaration-statement)
       (expression-operations (l.find stm ':initializer)))
      ((equal (car stm) 'assignment-statement)
       (expression-operations (l.find stm ':expression)))
      ((equal (car stm) 'return-statement)
       (expression-operations (l.find stm ':expression)))
      ((equal (car stm) 'assert-statement)
       (expression-operations (l.find stm ':expression)))
      ((equal (car stm) 'goto-statement)
       ())
      ((equal (car stm) 'label-statement)
       ())
      (t (error 'no-statement (list stm)))))
  

;; program [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun program-operations (prgm acc)
  (list.foldr #'(lambda (declaration acc)
		  (cond ((equal (car declaration) 'simple-declaration)
			 (list-union (expression-operations (l.find declaration ':initializer)) acc))
			((equal (car declaration) 'function-declaration)
			 (list-union (statement-operations (l.find declaration ':body)) acc))))
	      acc (l.find prgm ':declarations)))


(defun expression-to-sexp (exp)
  (cond ((equal (car exp) 'literal-expression) 
	 (l.find exp ':value))
	((equal (car exp) 'id-expression)
	 (var.ACL2-var (l.find exp ':var))) 
	((equal (car exp) 'unary-expression)
	 (list (unary-operator-to-ACL2-unary-operator (l.find exp ':operator))
	       (expression-to-sexp (l.find exp ':operand))))
	((equal (car exp) 'binary-expression)
	 (list (binary-operator-to-ACL2-binary-operator (l.find exp ':operator))
	       (expression-to-sexp (l.find exp ':operand1))
	       (expression-to-sexp (l.find exp ':operand1))))
	((equal (car exp) 'nondeterministic-expression)
	 (error 'no-conversion (list 'nondet 'in 'sexp)))
	((equal (car exp) 'conditional-expression)
	 (error 'no-conversion (list 'cond 'in 'sexp)))
	(t (error 'no-expression (list exp)))))

(defun expression-mod-bottoms (exp)
  (cond ((equal (car exp) 'literal-expression) 
	 ())
	((equal (car exp) 'id-expression)
	 ())
	((equal (car exp) 'unary-expression)
	 (expression-mod-bottoms (l.find exp ':operand)))
	((equal (car exp) 'binary-expression)
	 (list-union (if (equal (binary-operator-to-ACL2-binary-operator (l.find exp ':operator)) 'c-mod)
			 (list (expression-to-sexp (l.find exp ':operand2)))
		       ())
		     (list-union (expression-mod-bottoms (l.find exp ':operand1))
				 (expression-mod-bottoms (l.find exp ':operand2)))))
	((equal (car exp) 'nondeterministic-expression)
	 ())
	((equal (car exp) 'conditional-expression)
	 (list-union (expression-mod-bottoms (l.find exp ':test))
		     (list-union (expression-mod-bottoms (l.find exp ':then))
				 (expression-mod-bottoms (l.find exp ':else)))))
	(t (error 'no-expression (list exp)))))

(defun statement-mod-bottoms (stm)
(cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm acc)
			 (list-union (statement-mod-bottoms stm) acc))
		     () (l.find stm ':statements)))
      ((equal (car stm) 'if-then-statement)
       (list-union (expression-mod-bottoms (l.find stm ':test))
		   (statement-mod-bottoms (l.find stm ':then))))
      ((equal (car stm) 'if-then-else-statement)
       (list-union (expression-mod-bottoms (l.find stm ':test))
		   (list-union (statement-mod-bottoms (l.find stm ':then))
			       (statement-mod-bottoms (l.find stm ':else)))))
      ((equal (car stm) 'while-statement)
       (list-union (expression-mod-bottoms (l.find stm ':test))
		   (statement-mod-bottoms (l.find stm ':body))))
      ((equal (car stm) 'do-statement)
       (list-union (expression-mod-bottoms (l.find stm ':test))
		   (statement-mod-bottoms (l.find stm ':body))))
      ((equal (car stm) 'for-statement)
       (list-union (statement-mod-bottoms (l.find stm ':init))
		   (list-union (statement-mod-bottoms (l.find stm ':iter))
			       (list-union (statement-mod-bottoms (l.find stm ':body))
					   (expression-mod-bottoms (l.find stm ':test))))))
      ((equal (car stm) 'break-statement)
       ())
      ((equal (car stm) 'continue-statement)
       ())
      ((equal (car stm) 'empty-statement)
       ())
      ((equal (car stm) 'declaration-statement)
       (expression-mod-bottoms (l.find stm ':initializer)))
      ((equal (car stm) 'assignment-statement)
       (expression-mod-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'return-statement)
       (expression-mod-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'assert-statement)
       (expression-mod-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'goto-statement)
       ())
      ((equal (car stm) 'label-statement)
       ())
      (t (error 'no-statement (list stm)))))
  

;; program [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun program-mod-bottoms (prgm acc)
  (list.foldr #'(lambda (declaration acc)
		  (cond ((equal (car declaration) 'simple-declaration)
			 (list-union (expression-mod-bottoms (l.find declaration ':initializer)) acc))
			((equal (car declaration) 'function-declaration)
			 (list-union (statement-mod-bottoms (l.find declaration ':body)) acc))))
	      acc (l.find prgm ':declarations)))

(defun expression-division-bottoms (exp)
  (cond ((equal (car exp) 'literal-expression) 
	 ())
	((equal (car exp) 'id-expression)
	 ())
	((equal (car exp) 'unary-expression)
	 (expression-division-bottoms (l.find exp ':operand)))
	((equal (car exp) 'binary-expression)
	 (list-union (if (or (equal (binary-operator-to-ACL2-binary-operator (l.find exp ':operator)) 'c-uint-/)
			     (equal (binary-operator-to-ACL2-binary-operator (l.find exp ':operator)) 'c-int-/))
			 (list (expression-to-sexp (l.find exp ':operand2)))
		       ())
		     (list-union (expression-division-bottoms (l.find exp ':operand1))
				 (expression-division-bottoms (l.find exp ':operand2)))))
	((equal (car exp) 'nondeterministic-expression)
	 ())
	((equal (car exp) 'conditional-expression)
	 (list-union (expression-division-bottoms (l.find exp ':test))
		     (list-union (expression-division-bottoms (l.find exp ':then))
				 (expression-division-bottoms (l.find exp ':else)))))
	(t (error 'no-expression (list exp)))))

(defun statement-division-bottoms (stm)
(cond ((equal (car stm) 'compound-statement)
	 (list.foldr #'(lambda (stm acc)
			 (list-union (statement-division-bottoms stm) acc))
		     () (l.find stm ':statements)))
      ((equal (car stm) 'if-then-statement)
       (list-union (expression-division-bottoms (l.find stm ':test))
		   (statement-division-bottoms (l.find stm ':then))))
      ((equal (car stm) 'if-then-else-statement)
       (list-union (expression-division-bottoms (l.find stm ':test))
		   (list-union (statement-division-bottoms (l.find stm ':then))
			       (statement-division-bottoms (l.find stm ':else)))))
      ((equal (car stm) 'while-statement)
       (list-union (expression-division-bottoms (l.find stm ':test))
		   (statement-division-bottoms (l.find stm ':body))))
      ((equal (car stm) 'do-statement)
       (list-union (expression-division-bottoms (l.find stm ':test))
		   (statement-division-bottoms (l.find stm ':body))))
      ((equal (car stm) 'for-statement)
       (list-union (statement-division-bottoms (l.find stm ':init))
		   (list-union (statement-division-bottoms (l.find stm ':iter))
			       (list-union (statement-division-bottoms (l.find stm ':body))
					   (expression-division-bottoms (l.find stm ':test))))))
      ((equal (car stm) 'break-statement)
       ())
      ((equal (car stm) 'continue-statement)
       ())
      ((equal (car stm) 'empty-statement)
       ())
      ((equal (car stm) 'declaration-statement)
       (expression-division-bottoms (l.find stm ':initializer)))
      ((equal (car stm) 'assignment-statement)
       (expression-division-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'return-statement)
       (expression-division-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'assert-statement)
       (expression-division-bottoms (l.find stm ':expression)))
      ((equal (car stm) 'goto-statement)
       ())
      ((equal (car stm) 'label-statement)
       ())
      (t (error 'no-statement (list stm)))))
  

;; program [(list value ACL2-type) list] -> [(list value ACL2-type) list] 
(defun program-division-bottoms (prgm acc)
  (list.foldr #'(lambda (declaration acc)
		  (cond ((equal (car declaration) 'simple-declaration)
			 (list-union (expression-division-bottoms (l.find declaration ':initializer)) acc))
			((equal (car declaration) 'function-declaration)
			 (list-union (statement-division-bottoms (l.find declaration ':body)) acc))))
	      acc (l.find prgm ':declarations)))


(defun expression-replace-constants (exp const-pairs)
  (let* ((type (l.find exp ':type))
	 (loc (l.find exp ':loc))
	 (source-code (l.find exp ':source-code)))
    (cond ((equal (car exp) 'literal-expression) 
	   (let* ((value (l.find exp ':value))
		  (new? (list.find #'(lambda (pair)
				       (let* ((value* (car (car pair))) (type* (cadr (car pair))) (var* (cadr pair)))
					 (and (equal value value*) (equal (type-to-ACL2-type type) type*))))
				   const-pairs)))
	     (if (option.exists new?)
		 (let* ((var (cadr (option.get new?))))
		   (list 'id-expression ':type type ':loc loc ':source-code source-code
			 ':var var))
	       exp)))
	   ((equal (car exp) 'id-expression)
	    exp)
	   ((equal (car exp) 'unary-expression)
	    (list 'unary-expression ':type type ':loc loc ':source-code source-code
		  ':operator (l.find exp ':operator)
		  ':operand (expression-replace-constants (l.find exp ':operand) const-pairs)))
	   ((equal (car exp) 'binary-expression)
	    (list 'binary-expression ':type type ':loc loc ':source-code source-code
		  ':operator (l.find exp ':operator)
		  ':operand1 (expression-replace-constants (l.find exp ':operand1) const-pairs)
		  ':operand2 (expression-replace-constants (l.find exp ':operand2) const-pairs)))
	   ((equal (car exp) 'nondeterministic-expression)
	    exp)
	   ((equal (car exp) 'conditional-expression)
	    (list 'conditional-expression ':type type ':loc loc ':source-code source-code
		  ':test (expression-replace-constants (l.find exp ':test) const-pairs)
		  ':then (expression-replace-constants (l.find exp ':then) const-pairs)
		  ':else (expression-replace-constants (l.find exp ':else) const-pairs)))
	   (t (error 'no-expression (list exp))))))

(defun statement-replace-constants (stm const-pairs)
  (let* ((loc (l.find stm ':loc))
	 (source-code (l.find stm ':source-code)))
    (cond ((equal (car stm) 'compound-statement)
	   (list 'compound-statement ':loc loc ':source-code source-code
		 ':statements (list.map #'(lambda (stm*) (statement-replace-constants stm* const-pairs))
					(l.find stm ':statements))))
	  ((equal (car stm) 'if-then-statement)
	   (list 'if-then-statement ':loc loc ':source-code source-code
                   ':test (expression-replace-constants (l.find stm ':test) const-pairs)
                   ':then (statement-replace-constants (l.find stm ':then) const-pairs)))

      ((equal (car stm) 'if-then-else-statement)
       (list 'if-then-else-statement ':loc loc ':source-code source-code
	     ':test (expression-replace-constants (l.find stm ':test) const-pairs)
	     ':then (statement-replace-constants (l.find stm ':then) const-pairs)
	     ':else (statement-replace-constants (l.find stm ':else) const-pairs)))

      ((equal (car stm) 'while-statement)
       (list 'while-statement ':loc loc ':source-code source-code
	     ':test (expression-replace-constants (l.find stm ':test) const-pairs)
	     ':body (statement-replace-constants (l.find stm ':body) const-pairs)))
      ((equal (car stm) 'do-statement)
       (list 'do-statement ':loc loc ':source-code source-code
	     ':test (expression-replace-constants (l.find stm ':test) const-pairs)
	     ':body (statement-replace-constants (l.find stm ':body) const-pairs)))
      ((equal (car stm) 'for-statement)
       (list 'for-statement ':loc loc ':source-code source-code
	     ':init (statement-replace-constants (l.find stm ':init) const-pairs)
	     ':test (expression-replace-constants (l.find stm ':test) const-pairs)
	     ':body (statement-replace-constants (l.find stm ':body) const-pairs)
	     ':iter (statement-replace-constants (l.find stm ':iter) const-pairs)))
      ((equal (car stm) 'break-statement)
       stm)
      ((equal (car stm) 'continue-statement)
       stm)
      ((equal (car stm) 'empty-statement)
       stm)
      ((equal (car stm) 'declaration-statement)
       (list 'declaration-statement ':loc loc ':source-code source-code
	     ':declaring (l.find stm ':declaring)
	     ':initializer (expression-replace-constants (l.find stm ':initializer) const-pairs)))
	     
      ((equal (car stm) 'assignment-statement)
       (list 'assignment-statement ':loc loc ':source-code source-code
	     ':lvalue (l.find stm ':lvalue)
	     ':expression (expression-replace-constants (l.find stm ':expression) const-pairs)))

      ((equal (car stm) 'return-statement)
       (list 'return-statement ':loc loc ':source-code source-code
	     ':expression (expression-replace-constants (l.find stm ':expression) const-pairs)))

      ((equal (car stm) 'assert-statement)
       (list 'assert-statement ':loc loc ':source-code source-code
	     ':expression (expression-replace-constants (l.find stm ':expression) const-pairs)))

      ((equal (car stm) 'goto-statement)
       stm)
      ((equal (car stm) 'label-statement)
       stm)
      (t (error 'no-statement (list stm))))))

;; program [(list (list const type) expression) list] -> program
;; replaces all of the occurences of the listed constants with the associated terms
(defun program-replace-constants (prgm const-pairs)
  (list 'program
	':declarations (list.map #'(lambda (declaration)
				     (cond ((equal (car declaration) 'simple-declaration)
					    (list 'simple-declaration
						  ':declaring (l.find declaration ':declaring)
						  ':initializer (expression-replace-constants (l.find declaration ':initializer) const-pairs)
						  ':source-code (l.find declaration ':source-code)
						  ':loc (l.find declaration ':loc)))
					   ((equal (car declaration) 'function-declaration)
					    (list 'function-declaration
						  ':name (l.find declaration ':name)
						  ':parameters (l.find declaration ':parameters)
						  ':return-type (l.find declaration ':return-type)
						  ':body (statement-replace-constants (l.find declaration ':body) const-pairs)
						  ':dec-loc (l.find declaration ':dec-loc)
						  ':source-code (l.find declaration ':source-code)
						  ':loc (l.find declaration ':loc)))))
				 (l.find prgm ':declarations))))

;; program Z -> (list program [(list (list const type) var) list])
(defun program-generalize-constants (prgm limit)
  (let* ((constants (program-constants prgm ()))
	 (constants* (list.filter #'(lambda (pair)
				      (let* ((const (car pair)))
					(> const limit)))
				  constants))
	 (const-pairs (list.map #'(lambda (pair)
				    (list pair (pair.make (new-var-name) '_)))
				constants*))
	 (prgm* (program-replace-constants prgm const-pairs)))
    (list prgm* const-pairs)))

(defun create-printable-lvalue (lvalue)
  (l.find lvalue ':var))

;; expression -> ?
(defun create-printable-expression (exp)
  (cond ((equal (car exp) 'literal-expression)
	 (list 'literal-expression
	       ':value (l.find exp ':value)))
	((equal (car exp) 'id-expression)
	 (list 'id-expression
	       ':var (l.find exp ':var)))
	((equal (car exp) 'unary-expression)
	 (list 'unary-expression
	       ':operator (l.find exp ':operator)
	       ':operand (create-printable-expression (l.find exp ':operand))))
	((equal (car exp) 'binary-expression)
	 (list 'binary-expression
	       ':operator (l.find exp ':operator)
	       ':operand1 (create-printable-expression (l.find exp ':operand1))
	       ':operand2 (create-printable-expression (l.find exp ':operand2))))
	((equal (car exp) 'nondeterministic-expression)
	 (list 'nondeterministic-expression))
	((equal (car exp) 'conditional-expression)
	 (list 'conditional-expression
	       ':test (create-printable-expression (l.find exp ':test))
	       ':then (create-printable-expression (l.find exp ':then))
	       ':else (create-printable-expression (l.find exp ':else))))
	(t (list 'unknown-expression exp))))

;; statement -> ?
(defun create-printable-statement (stm)
  (cond ((equal (car stm) 'compound-statement)
	 (list 'compound-statement
	       ':statements (list.map #'create-printable-statement (l.find stm ':statements))))
	((equal (car stm) 'if-then-statement)
	 (list 'if-then-statement
	       ':test (create-printable-expression (l.find stm ':test))
	       ':then (create-printable-statement (l.find stm ':then))))
	((equal (car stm) 'if-then-else-statement)
	 (list 'if-then-else-statement
	       ':test (create-printable-expression (l.find stm ':test))
	       ':then (create-printable-statement (l.find stm ':then))
	       ':else (create-printable-statement (l.find stm ':else))))

	((equal (car stm) 'while-statement)
	 (list 'while-statement
	       ':test (create-printable-expression (l.find stm ':test))
	       ':body (create-printable-statement (l.find stm ':body))))

	((equal (car stm) 'do-statement)
	 (list 'do-statement
	       ':body (create-printable-statement (l.find stm ':body))
	       ':test (create-printable-expression (l.find stm ':test))))

	((equal (car stm) 'for-statement)
	 (list 'for-statement
	       ':init (create-printable-statement (l.find stm ':init))
	       ':test (create-printable-expression (l.find stm ':test))
	       ':iter (create-printable-statement (l.find stm ':iter))
	       ':body (create-printable-statement (l.find stm ':body))))
	((equal (car stm) 'break-statement)
	 (list 'break-statement))
	((equal (car stm) 'continue-statement)
	 (list 'continue-statement))
	((equal (car stm) 'declaration-statement)
	 (list 'declaration-statement
	       ':declaring (l.find stm ':declaring)
	       ':initializer (create-printable-expression (l.find stm ':initializer))))
	((equal (car stm) 'assignment-statement)
	 (list 'assignment-statement
	       ':lvalue (create-printable-lvalue (l.find stm ':lvalue))
	       ':expression (create-printable-expression (l.find stm ':expression))))
	((equal (car stm) 'return-statement)
	 (list 'return-statement
	       ':expression (create-printable-expression (l.find stm ':expression))))
	((equal (car stm) 'assert-statement)
	 (list 'assert-statement
	       ':expression (create-printable-expression (l.find stm ':expression))))
	((equal (car stm) 'empty-statement)
	 (list 'empty-statement))
	((equal (car stm) 'goto-statement)
	 (list 'goto-statement
	       ':label (l.find stm ':label)))
	((equal (car stm) 'label-statement)
	 (list 'label-statement
	       ':label (l.find stm ':label)))
	(t (list 'unknown-statement stm))))

(defun create-printable-program (prgm)
  (list 'program
	':declarations (list.map #'(lambda (declaration)
				     (cond ((equal (car declaration) 'simple-declaration)
					    (list 'simple-declaration
						  ':declaring (l.find declaration ':declaring)
						  ':intializer (create-printable-expression (l.find declaration ':initializer))))
					   ((equal (car declaration) 'function-declaration)
					    (list 'function-declaration
						  ':name (l.find declaration ':name)
						  ':parameters (l.find declaration ':parameters)
						  ':return-type (l.find declaration ':return-type)
						  ':body (create-printable-statement (l.find declaration ':body))))))
				 (l.find prgm ':declarations))))
